image: python:3.10.5-slim

stages:
  - test
  - deploy

unit_test:
  stage: test
  script:
    - pip3 install poetry poethepoet
    - poetry install
    - poe lint --extend-ignore=F401 # unused-imports
    - poe type-check
    - poe test-coverage
    - poetry run coverage report
    - poetry run coverage xml
    - poetry run coverage html
  artifacts:
    paths:
      - htmlcov/
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
  coverage: '/^TOTAL.+?(\d+\%)$/'

pages:
  stage: deploy
  only:
    - main
    - develop
  script:
    - mkdir public
    - mv htmlcov/ public/
  artifacts:
    paths:
      - public
